from __future__ import division
import sys
import binascii
import numpy as np
import scipy
from scipy import signal
import pylab
import mahotas
from scipy import ndimage
from numpy import *
from numpy.fft import *
import PIL
from PIL import Image
import StringIO
import matplotlib
from skimage.feature.template import match_template as ncc 
import png
import numconv
from scipy.stats import t as scipystats
import numpy as np
import math

# TO DISPLAY A 3D PLOT...
#from mpl_toolkits.mplot3d import Axes3D
#from matplotlib import cm
#from matplotlib.ticker import LinearLocator, FixedLocator, FormatStrFormatter
#import matplotlib.pyplot as plt


filename = sys.argv[1]
alpha_arg = sys.argv[2]
data = loadtxt(filename,dtype="float",skiprows=0,unpack=True)
data= np.reshape(data, size(data,0)*size(data,1), order='C')
initialdata=data
data=array(data)
data2=data

alpha = np.float64(alpha_arg)

outlier=1

while outlier == 1:
	tmp=data2[np.where(data2 != np.nan)]
	meanval = np.mean(tmp)
	maxval = tmp[np.where(np.abs(tmp-meanval) == np.max(np.abs(tmp-meanval)))]
	sdval = np.std(tmp)
	tn = np.abs((maxval-meanval)/sdval)
	tcrit = -scipystats.isf(alpha/(2*size(tmp)), size(tmp)-2)
	critval = (size(tmp)-1)/sqrt(size(tmp))*(sqrt(square(tcrit)/(size(tmp)-2+(square(tcrit)))))
	if tn > critval:
		outlier = 1
	else:
		outlier = 0
	if outlier == 1:
		tmp = np.where(data2 == maxval)
		data2[tmp] = np.nan

idx = np.where(np.isnan(data2))
outliers = initialdata[idx]

print ("position:	" + str(idx))
print ("outliers:	" + str(outliers))
